Package icyllis.arc3d.compiler.tree

# Enum Class Node.ExpressionKind

java.lang.Object
java.lang.Enum<Node.ExpressionKind>
icyllis.arc3d.compiler.tree.Node.ExpressionKind

All Implemented Interfaces:
  `Serializable`, `Comparable<Node.ExpressionKind>`, `Constable`

Enclosing class:
  `Node`

public static enum Node.ExpressionKind extends Enum<Node.ExpressionKind>

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `BINARY`
  `CONDITIONAL`
  `CONSTRUCTOR_ARRAY`
  `CONSTRUCTOR_ARRAY_CAST`
  `CONSTRUCTOR_COMPOUND`
  `CONSTRUCTOR_COMPOUND_CAST`
  `CONSTRUCTOR_DIAGONAL_MATRIX`
  `CONSTRUCTOR_MATRIX_RESIZE`
  `CONSTRUCTOR_SCALAR_CAST`
  `CONSTRUCTOR_STRUCT`
  `CONSTRUCTOR_VECTOR_SPLAT`
  `FIELD_ACCESS`
  `FUNCTION_CALL`
  `FUNCTION_REFERENCE`
  `INDEX`
  `LITERAL`
  `POISON`
  `POSTFIX`
  `PREFIX`
  `SWIZZLE`
  `TYPE_REFERENCE`
  `VARIABLE_REFERENCE`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Class<? extends Expression>`
  `getType()`
  `static Node.ExpressionKind`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static Node.ExpressionKind[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### BINARY

    public static final Node.ExpressionKind BINARY

  - ### CONDITIONAL

    public static final Node.ExpressionKind CONDITIONAL

  - ### CONSTRUCTOR_ARRAY

    public static final Node.ExpressionKind CONSTRUCTOR_ARRAY

  - ### CONSTRUCTOR_ARRAY_CAST

    public static final Node.ExpressionKind CONSTRUCTOR_ARRAY_CAST

  - ### CONSTRUCTOR_COMPOUND

    public static final Node.ExpressionKind CONSTRUCTOR_COMPOUND

  - ### CONSTRUCTOR_COMPOUND_CAST

    public static final Node.ExpressionKind CONSTRUCTOR_COMPOUND_CAST

  - ### CONSTRUCTOR_DIAGONAL_MATRIX

    public static final Node.ExpressionKind CONSTRUCTOR_DIAGONAL_MATRIX

  - ### CONSTRUCTOR_MATRIX_RESIZE

    public static final Node.ExpressionKind CONSTRUCTOR_MATRIX_RESIZE

  - ### CONSTRUCTOR_SCALAR_CAST

    public static final Node.ExpressionKind CONSTRUCTOR_SCALAR_CAST

  - ### CONSTRUCTOR_STRUCT

    public static final Node.ExpressionKind CONSTRUCTOR_STRUCT

  - ### CONSTRUCTOR_VECTOR_SPLAT

    public static final Node.ExpressionKind CONSTRUCTOR_VECTOR_SPLAT

  - ### FIELD_ACCESS

    public static final Node.ExpressionKind FIELD_ACCESS

  - ### FUNCTION_CALL

    public static final Node.ExpressionKind FUNCTION_CALL

  - ### FUNCTION_REFERENCE

    public static final Node.ExpressionKind FUNCTION_REFERENCE

  - ### INDEX

    public static final Node.ExpressionKind INDEX

  - ### LITERAL

    public static final Node.ExpressionKind LITERAL

  - ### POISON

    public static final Node.ExpressionKind POISON

  - ### POSTFIX

    public static final Node.ExpressionKind POSTFIX

  - ### PREFIX

    public static final Node.ExpressionKind PREFIX

  - ### SWIZZLE

    public static final Node.ExpressionKind SWIZZLE

  - ### TYPE_REFERENCE

    public static final Node.ExpressionKind TYPE_REFERENCE

  - ### VARIABLE_REFERENCE

    public static final Node.ExpressionKind VARIABLE_REFERENCE

- ## Method Details

  - ### values

    public static Node.ExpressionKind[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static Node.ExpressionKind valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### getType

    public Class<? extends Expression> getType()